// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_FAssetData
	{
	public:
		virtual ~ISCW_FAssetData() = default;

		virtual wstring GetPackageName() const = 0;
		
		virtual shared_ptr<ISCW_FAssetData> ToFAssetDataPtr() = 0;
		virtual shared_ptr<const ISCW_FAssetData> ToFAssetDataPtr() const = 0;
	};

	using ISCW_FAssetDataConstPtr = shared_ptr<const ISCW_FAssetData>;
	using ISCW_FAssetDataPtr = shared_ptr<ISCW_FAssetData>;
} // namespace Sourcify